#ifndef __GETOPT_HPP__
#define __GETOPT_HPP__

#ifdef WIN32

extern char *optarg;
extern int optind;
extern int opterr;
extern int optopt;

struct option
{
	char *name;
	int has_arg;
	int *flag;
	int val;
};

#define no_argument			0
#define required_argument	1
#define optional_argument	2

extern int getopt(int, char **, const char *);
extern int getopt_long(int, char **, const char *, const struct option *, int *);
extern int getopt_long_only(int, char **, const char *, const struct option *, int *);
extern int _getopt_internal(int, char **, const char *, const struct option *, int *, int);

#endif // WIN32

#endif // __GETOPT_HPP__