#ifndef __GROUP_HPP__
#define __GROUP_HPP__

#include <time.h>
#include <stdio.h>
#include <sys/types.h>

#include "config.h"
#include "entry.hpp"

// Structure definition
struct group
{
	char *gr_name;								// group name
	char *gr_passwd;							// password
	gid_t gr_gid;								// group ID
	char **gr_mem;								// member list
};

class CGroupEntry : public CEntry
{
	public:
		CGroupEntry(FILE *);
		CGroupEntry(char *, gid_t, char *);
		~CGroupEntry();
	
	public:
		char *GetName();
		char *GetPassword();
		char *GetGecos() { return NULL; }						// dummy
		char *GetHome() { return NULL; }							// dummy	
		gid_t GetGroup();
		bool SetPassword(char *, int, int, int, int);
		bool SetGecos(char *) { return false; }				// dummy
		bool PutEntry(FILE *);
	
		inline struct group *GetEntry() { return &strEntry; }
	
	private:
		char *GetMembers();
		bool SetMembers(char *);
	
		static bool GetEntry(char *, void *);
	
	private:
		struct group strEntry;
};

#endif // __GROUP_HPP__