#ifndef __GSHADOW_HPP__
#define __GSHADOW_HPP__

#include <time.h>
#include <stdio.h>
#include <sys/types.h>

#include "config.h"
#include "entry.hpp"

// Structure definition
struct sgrp
{
	char *sg_name;								// login name
	char *sg_passwd;							// encrypted password
	char **sg_adm;								// group administrator list
	char **sg_mem;								// group membership list
};

class CGshadowEntry : public CEntry
{
	public:
		CGshadowEntry(FILE *);
		CGshadowEntry(char *, char *, char *);
		~CGshadowEntry();
	
	public:
		char *GetName();
		char *GetPassword();
		char *GetMembers();
		char *GetAdmins();
		char *GetGecos() { return NULL; }					// dummy
		char *GetHome() { return NULL; }						// dummy	
		gid_t GetGroup() { return (gid_t)-1; }				// dummy
		uid_t GetUser() { return (uid_t)-1; }				// dummy
		bool SetPassword(char *, int, int, int, int);
		bool SetGecos(char *) { return false; }			// dummy
		bool PutEntry(FILE *);
		bool IsAdmin(char *);
	
		inline struct sgrp *GetEntry() { return &strEntry; }
	
	private:
		static bool GetEntry(char *, void *);
		bool SetAdmins(char *);
		bool SetMembers(char *);
	
	private:
		struct sgrp strEntry;
};

#endif // __GSHADOW_HPP__