#ifndef __KEEPER_HPP__
#define __KEEPER_HPP__

#define DIRECTION_IN						'<'
#define DIRECTION_OUT					'>'

#define PARAM_STRING						's'
#define PARAM_PASSWORD					'p'
#define PARAM_INTEGER					'i'
#define PARAM_BYTE						'b'

#define SEQUENCE_USER_PASSWORD		"<b>s>p<b>b>s>p>i>i>i>i<b"
#define SEQUENCE_GROUP_PASSWORD		"<b>s>p<b>b>s>p<b"
#define SEQUENCE_ADD_USER				"<b>s>p<b>b>s>s>s>s>i>i<b"
#define SEQUENCE_DEL_USER				"<b>s>p<b>b>s<b"
#define SEQUENCE_ADD_GROUP				"<b>s>p<b>b>s>s>s<b"
#define SEQUENCE_DELETE_GROUP			"<b>s>p<b>b>s<b"
#define SEQUENCE_CHFN					"<b>s>p<b>b>s>s>s>s>s>s<b"

#include "tokenized_string.hpp"

class CKeeper
{
	public:
		CKeeper(CStringArray *, char *, ...);
		~CKeeper();
		bool Try();
		bool TryHost(int);
	
	private:
		int iParams;
		char *pszSequence;
		void **ppvParameters;
		CStringArray *pHosts;
};

// Function prototypes
bool Postpone(CKeeper *);

#endif // __KEEPER_HPP__